# coding: utf-8


"""
IGNORE:
    Nutanix Licensing APIs

    licensing desc placeholder  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_licensing_py_client.models.licensing.v4.config.BaseClusterInfo import BaseClusterInfo  # noqa: F401,E501
from ntnx_licensing_py_client.models.licensing.v4.config.ClusterType import ClusterType  # noqa: F401,E501
from ntnx_licensing_py_client.models.licensing.v4.config.EntitlementDetail import EntitlementDetail  # noqa: F401,E501

class Entitlement(BaseClusterInfo):

    """Model capturing entitlement details.

    :param cluster_ext_id: (:attr:`cluster_ext_id`) Attribute for capturing cluster UUID for entitlement.
    :type cluster_ext_id: 
    
    
    :param is_registered: (:attr:`is_registered`) Indicates whether cluster is registered with PC or not.
    :type is_registered: 
    
    
    :param name: (:attr:`name`) Indicates the name of the license. Possible values could be NCI Pro, NCM Ultimate.
    :type name: 
     max=100 chars
    
    :param type: (:attr:`type`) 
    :type type: 
    
    
    :param details: (:attr:`details`) Attribute for capturing a collection of entitlement details.
    :type details: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'cluster_ext_id': 'str',
        'is_registered': 'bool',
        'name': 'str',
        'type': 'licensing.v4.config.ClusterType',
        'details': 'list[licensing.v4.config.EntitlementDetail]',
        'is_multicluster': 'bool',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'cluster_ext_id': 'clusterExtId',
        'is_registered': 'isRegistered',
        'name': 'name',
        'type': 'type',
        'details': 'details',
        'is_multicluster': 'isMulticluster',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, cluster_ext_id=None, is_registered=None, name=None, type=None, details=None, is_multicluster=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        BaseClusterInfo.__init__(self, is_multicluster, ext_id, links, tenant_id, *args, **kwargs)
        self.__cluster_ext_id = None
        self.__is_registered = None
        self.__name = None
        self.__type = None
        self.__details = None
        self.discriminator = None
        if cluster_ext_id is not None:
            self.__cluster_ext_id = cluster_ext_id
        if is_registered is not None:
            self.__is_registered = is_registered
        if name is not None:
            self.__name = name
        if type is not None:
            self.__type = type
        if details is not None:
            self.__details = details

    def _initialize_object_type(self):
        return 'licensing.v4.config.Entitlement'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def cluster_ext_id(self):
        """
        Attribute for capturing cluster UUID for entitlement.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__cluster_ext_id

    @cluster_ext_id.setter
    def cluster_ext_id(self, cluster_ext_id):
        if cluster_ext_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', cluster_ext_id):  # noqa: E501
            raise ValueError(r"Invalid value for `cluster_ext_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__cluster_ext_id = cluster_ext_id

    @property
    def is_registered(self):
        """
        Indicates whether cluster is registered with PC or not.

        :type:
                :class:`~bool`
        """  # noqa: E501
        return self.__is_registered

    @is_registered.setter
    def is_registered(self, is_registered):

        self.__is_registered = is_registered

    @property
    def name(self):
        """
        Indicates the name of the license. Possible values could be NCI Pro, NCM Ultimate.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is not None and len(name) > 100:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `100`")  # noqa: E501

        self.__name = name

    @property
    def type(self):
        """
        

        :type:
            :class:`~ntnx_licensing_py_client.models.licensing.v4.config.ClusterType`
        """  # noqa: E501
        return self.__type

    @type.setter
    def type(self, type):

        self.__type = type

    @property
    def details(self):
        """
        Attribute for capturing a collection of entitlement details.

        :type:
             list[ :class:`~ntnx_licensing_py_client.models.licensing.v4.config.EntitlementDetail` ]
        """  # noqa: E501
        return self.__details

    @details.setter
    def details(self, details):

        self.__details = details

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Entitlement, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Entitlement):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

