# coding: utf-8


"""
IGNORE:
    Nutanix Licensing APIs

    licensing desc placeholder  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_licensing_py_client.models.licensing.v4.config.BaseLicenseInfo import BaseLicenseInfo  # noqa: F401,E501
from ntnx_licensing_py_client.models.licensing.v4.config.LicenseCategory import LicenseCategory  # noqa: F401,E501
from ntnx_licensing_py_client.models.licensing.v4.config.LicenseType import LicenseType  # noqa: F401,E501
from ntnx_licensing_py_client.models.licensing.v4.config.Meter import Meter  # noqa: F401,E501
from ntnx_licensing_py_client.models.licensing.v4.config.SubCategory import SubCategory  # noqa: F401,E501

class ExpiredLicense(BaseLicenseInfo):

    """License details of expired license.

    :param license_id: (:attr:`license_id`) License ID of expired license.
    :type license_id: 
    
    
    :param meter: (:attr:`meter`) 
    :type meter: 
    
    
    :param used_quantity: (:attr:`used_quantity`) Indicates the expired quantity of the license.
    :type used_quantity: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'license_id': 'str',
        'meter': 'licensing.v4.config.Meter',
        'used_quantity': 'float',
        'name': 'str',
        'type': 'licensing.v4.config.LicenseType',
        'category': 'licensing.v4.config.LicenseCategory',
        'sub_category': 'licensing.v4.config.SubCategory',
        'expiry_date': 'date',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'license_id': 'licenseId',
        'meter': 'meter',
        'used_quantity': 'usedQuantity',
        'name': 'name',
        'type': 'type',
        'category': 'category',
        'sub_category': 'subCategory',
        'expiry_date': 'expiryDate',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, license_id=None, meter=None, used_quantity=None, name=None, type=None, category=None, sub_category=None, expiry_date=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        BaseLicenseInfo.__init__(self, name, type, category, sub_category, expiry_date, ext_id, links, tenant_id, *args, **kwargs)
        self.__license_id = None
        self.__meter = None
        self.__used_quantity = None
        self.discriminator = None
        if license_id is not None:
            self.__license_id = license_id
        if meter is not None:
            self.__meter = meter
        if used_quantity is not None:
            self.__used_quantity = used_quantity

    def _initialize_object_type(self):
        return 'licensing.v4.config.ExpiredLicense'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def license_id(self):
        """
        License ID of expired license.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__license_id

    @license_id.setter
    def license_id(self, license_id):
        if license_id is not None and not re.search('^[A-Za-z0-9-]+$', license_id):  # noqa: E501
            raise ValueError(r"Invalid value for `license_id`, must be a follow pattern or equal to `/^[A-Za-z0-9-]+$/`")  # noqa: E501

        self.__license_id = license_id

    @property
    def meter(self):
        """
        

        :type:
            :class:`~ntnx_licensing_py_client.models.licensing.v4.config.Meter`
        """  # noqa: E501
        return self.__meter

    @meter.setter
    def meter(self, meter):

        self.__meter = meter

    @property
    def used_quantity(self):
        """
        Indicates the expired quantity of the license.

        :type:
                :class:`~float`
        """  # noqa: E501
        return self.__used_quantity

    @used_quantity.setter
    def used_quantity(self, used_quantity):

        self.__used_quantity = used_quantity

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ExpiredLicense, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExpiredLicense):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

