# coding: utf-8


"""
IGNORE:
    Nutanix Licensing APIs

    licensing desc placeholder  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_licensing_py_client.models.licensing.v4.config.BaseClusterInfo import BaseClusterInfo  # noqa: F401,E501
from ntnx_licensing_py_client.models.licensing.v4.config.CapacityViolation import CapacityViolation  # noqa: F401,E501
from ntnx_licensing_py_client.models.licensing.v4.config.ExpiredLicense import ExpiredLicense  # noqa: F401,E501
from ntnx_licensing_py_client.models.licensing.v4.config.FeatureViolation import FeatureViolation  # noqa: F401,E501

class Violation(BaseClusterInfo):

    """Response object containing cluster and associated features violations.

    :param feature_violations: (:attr:`feature_violations`) List of features which are being used by cluster without applying necessary licenses. Feature violations can be resolved by applying necessary licenses.
    :type feature_violations: 
    
    
    :param capacity_violations: (:attr:`capacity_violations`) List of capacity violations. Capacity violations are thrown when user has not applied licenses to extended capacity. Example: Cluster is expanded to have new nodes which are not licensed.
    :type capacity_violations: 
    
    
    :param expired_licenses: (:attr:`expired_licenses`) List of expired licenses for a cluster. Such licenses need to be replaced in order for the cluster to function properly.
    :type expired_licenses: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'feature_violations': 'list[licensing.v4.config.FeatureViolation]',
        'capacity_violations': 'list[licensing.v4.config.CapacityViolation]',
        'expired_licenses': 'list[licensing.v4.config.ExpiredLicense]',
        'is_multicluster': 'bool',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'feature_violations': 'featureViolations',
        'capacity_violations': 'capacityViolations',
        'expired_licenses': 'expiredLicenses',
        'is_multicluster': 'isMulticluster',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, feature_violations=None, capacity_violations=None, expired_licenses=None, is_multicluster=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        BaseClusterInfo.__init__(self, is_multicluster, ext_id, links, tenant_id, *args, **kwargs)
        self.__feature_violations = None
        self.__capacity_violations = None
        self.__expired_licenses = None
        self.discriminator = None
        if feature_violations is not None:
            self.__feature_violations = feature_violations
        if capacity_violations is not None:
            self.__capacity_violations = capacity_violations
        if expired_licenses is not None:
            self.__expired_licenses = expired_licenses

    def _initialize_object_type(self):
        return 'licensing.v4.config.Violation'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def feature_violations(self):
        """
        List of features which are being used by cluster without applying necessary licenses. Feature violations can be resolved by applying necessary licenses.

        :type:
             list[ :class:`~ntnx_licensing_py_client.models.licensing.v4.config.FeatureViolation` ]
        """  # noqa: E501
        return self.__feature_violations

    @feature_violations.setter
    def feature_violations(self, feature_violations):

        self.__feature_violations = feature_violations

    @property
    def capacity_violations(self):
        """
        List of capacity violations. Capacity violations are thrown when user has not applied licenses to extended capacity. Example: Cluster is expanded to have new nodes which are not licensed.

        :type:
             list[ :class:`~ntnx_licensing_py_client.models.licensing.v4.config.CapacityViolation` ]
        """  # noqa: E501
        return self.__capacity_violations

    @capacity_violations.setter
    def capacity_violations(self, capacity_violations):

        self.__capacity_violations = capacity_violations

    @property
    def expired_licenses(self):
        """
        List of expired licenses for a cluster. Such licenses need to be replaced in order for the cluster to function properly.

        :type:
             list[ :class:`~ntnx_licensing_py_client.models.licensing.v4.config.ExpiredLicense` ]
        """  # noqa: E501
        return self.__expired_licenses

    @expired_licenses.setter
    def expired_licenses(self, expired_licenses):

        self.__expired_licenses = expired_licenses

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Violation, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Violation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

